var rollup_pluginutils_1 = require('rollup-pluginutils');
var ts = require('typescript');
var object_assign_1 = require('object-assign');
function typescript(options) {
    options = object_assign_1.default({}, options || {});
    var filter = rollup_pluginutils_1.createFilter(options.include, options.exclude);
    delete options.include;
    delete options.exclude;
    return {
        transform: function (code, id) {
            if (!filter(id))
                return null;
            var transformed = ts.transpileModule(code, {
                compilerOptions: object_assign_1.default({
                    target: 1,
                    module: 5,
                    sourceMap: true
                }, options)
            });
            if (transformed.diagnostics) {
                transformed.diagnostics.forEach(function (diagnostic) {
                    var _a = diagnostic.file.getLineAndCharacterOfPosition(diagnostic.start), line = _a.line, character = _a.character;
                    var message = ts.flattenDiagnosticMessageText(diagnostic.messageText, '\n');
                    console.log(diagnostic.file.fileName + " (" + (line + 1) + "," + (character + 1) + "): " + message);
                });
            }
            return {
                code: transformed.outputText,
                map: JSON.parse(transformed.sourceMapText)
            };
        }
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = typescript;
